const got = require('@/utils/got');
const cheerio = require('cheerio');

module.exports = async (ctx) => {
    const rootUrl = 'http://www.iee.cas.cn/xwzx/kydt';
    const response = await got({
        method: 'get',
        url: rootUrl,
    });

    const $ = cheerio.load(response.data);
    const list = $('li.entry .entry-content-title')
        .slice(0, 15)
        .map((_, item) => {
            item = $(item);
            const a = item.find('a');
            return {
                title: a.text(),
                link: a.attr('href'),
            };
        })
        .get();

    const items = await Promise.all(
        list.map((item) =>
            ctx.cache.tryGet(item.link, async () => {
                const detailResponse = await got({
                    method: 'get',
                    url: item.link,
                });
                const content = cheerio.load(detailResponse.data);

                item.description = content('.article-content').html();
                item.pubDate = new Date(content('time').text().split('：')[1] + ' GMT+8').toUTCString();

                return item;
            })
        )
    );

    ctx.state.data = {
        title: '科研成果 - 中国科学院电工研究所',
        link: rootUrl,
        item: items,
    };
};
